/*****************************************************************************
 Copyright (c) 1993 UUNET Technologies
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.
 3. All advertising materials mentioning features or use of this software
    must display the following acknowledgement:
      This product includes software developed by UUNET Technologies
 4. The name UUNET Technologies may not be used to endorse or promote products  
    derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE UUNET Technologies ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 ARE DISCLAIMED.  IN NO EVENT SHALL THE UUNET Technologies BE LIABLE
 FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 SUCH DAMAGE.

*****************************************************************************/


#include <string.h>
#include <strings.h>

/* find val in str of n chars */

char *findncasestr(str, val, n)
     char *str, *val;
     int n;
{
  char first = tolower(*val); /* first character in string */
  int vlen = strlen(val);
  char *where;

  where = str;
  while (1) {
    for (; (tolower(*where) != first) && ((where - str) < n); where++)
      ;
    if ((where - str >= n) || ((n - (where - str)) < vlen))
      return NULL;
    if (strncasecmp(where, val, vlen) == 0)
      return where;
    where++;
  }
}
  
/* return location of value of header - returns 0 on failure */

/* headers = beginning of headers 
   header = what you're looking for (including colon, but not any whitespace)
   hslen = length of headers
   */

int findheadervalue(headers, hslen, header)
  char *header, *headers;
  int hslen;
{
  char *hloc, *hvloc;
  char *endheaders;

  endheaders = findncasestr(headers, "\n\n", hslen);
  if (endheaders != NULL) {
    hslen = endheaders - headers;
  }
  hloc = findncasestr(headers, header, hslen);

  if (!hloc) 
    return 0;

  hloc = strchr(hloc, ':');

  hloc++;

  while (*(hloc++)) {
    switch (*hloc) {
    case ' ':
    case '\t':
      break;
    default:
      goto out;
    }
    break;
  }

 out:

  return (hloc - headers);
}

